//-----------------------------------------
// ATCopyPause -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//                 2003/09/25  add Automaton Model
//  Save Acs3b\Automaton Local Rotaion 
//
//  use IKtoRotClient.ls 
//  use temporay dir [Content]/temp/localrot/
//parameter 
//  Save Local Rot file : load file name 
@version 2.5
@script generic
@name ATCopyPauseZ

@define AUTOMATON_VER 2.2

@define TYPE_AM  2 

sGlobalTRName = @"Root","R_HandCtrl","L_HandCtrl","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl","IKSlidHolder"@;
sGlobalLNameAM  = @"L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot"@;

sAMRotName   =  @"R_Shoulder","R_ArmRoot","R_ThighRoot","R_Arm","R_ForeArm","R_Hand",
				 "L_Shoulder","L_ArmRoot","L_ThighRoot","L_Arm","L_ForeArm","L_Hand",
				 "R_Hip","R_Thigh","R_Shin","R_FootDir","R_Foot","R_FootTip",
				 "L_Hip","L_Thigh","L_Shin","L_FootDir","L_Foot","L_FootTip",
				 "Root","RootSpin","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
				 "R_LegDir"  ,"L_LegDir",
				 "Neck_a"   ,"Neck_b"    ,"Neck_c" ,"Neck_d"  ,"Neck_e"      ,"Neck_f"       ,"Neck_g",
				 "Tail_a"   ,"Tail_b"    ,"Tail_c" ,"Tail_d"  ,"Tail_e"      ,"Tail_f"       ,"Tail_g","Tail_Null","Tail_Start",       
				 "Spine_a"  ,"Spine_b"   ,"Spine_c"@;
				 
sRotHand      = @"R_Thumb1"    ,"R_Thumb2"    ,"R_Thumb3"    ,
				"R_Index1"    ,"R_Index2"    ,"R_Index3"    ,
				"R_Middle1"   ,"R_Middle2"   ,"R_Middle3"   ,
				"R_Ring1"     ,"R_Ring2"     ,"R_Ring3"     ,
				"R_Pinky1"    ,"R_Pinky2"    ,"R_Pinky3"    ,
					               
				"L_Thumb1"    ,"L_Thumb2"    ,"L_Thumb3"    ,
				"L_Index1"    ,"L_Index2"    ,"L_Index3"    ,
				"L_Middle1"   ,"L_Middle2"   ,"L_Middle3"   ,
				"L_Ring1"     ,"L_Ring2"     ,"L_Ring3"     ,
				"L_Pinky1"    ,"L_Pinky2"    ,"L_Pinky3"    @;

s_asRotName ;
s_asControlRotName ;

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

/* searchItem */
s_xSearchItem = nil ;


generic 
{
	curScene = Scene();
	/* puah seleced item */
	xSelected = curScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}	
	push_selected_item( curScene , xSelected );
	
	curItem = select_by_name( s_xParentItem , "Master" );
	if( NULL == curItem )
	{
		error( "Top Item name is not [Master] " , "rename item name !!" );
		return ;
	}
	s_xParentItem = curItem ;
	
	initItemTable( nItemType );
	
	sFilePath = getdir("Content") + "\\temp\\localrot";
	/* collect motion data */
	fileName = sFilePath + "\\_tempPose.lrt" ;

	/* apply IKtoRotClient plugin */
	apply_server( s_xParentItem ) ;
	/* KtoRotClient plugin motion data Output */
	RefreshNow();
	/* collect motion data */
	files = matchfiles( sFilePath , "*.txt" );
	nOutputLocalRot = 0;
	var outputTextBuf ;
	for( i = 1 ; i <= files.count() ; i++ )
	{
		if( "Root" != files[ i ] )
		{
			// Open Item Rotation Data 
			sNullFileName = sFilePath + "\\" + files[ i ] ; 
			nullFile = File( sNullFileName , "r") ;
			if(nullFile.linecount())
			{
				sLine = nullFile.read() ;
				outputTextBuf += sLine ;
				nOutputLocalRot++ ;
			}
			nullFile.close();
		}
	}

	if((textFile = File( fileName , "w" ) ) == nil)
	{
		error("Dos not open file ", fileName );
		/* remove IKtoRotClient plugin */
		remove_server( s_xParentItem );
		return;		
	} 
	for( i = 1 ; i <= sGlobalTRName.count() ; i++ )
	{
		obj = curItem;
		outputLocalTR( obj , sGlobalTRName[ i ] , curScene.currenttime , textFile ) ;
	}	
	for( i = 1 ; i <= s_asControlRotName.count() ; i++ )
	{
		obj = curItem;
		outputLocalRot( obj , s_asControlRotName[ i ] , curScene.currenttime , textFile ) ;
	}
	for( i = 1 ; i <= sRotHand.count() ; i++ )
	{
		obj = curItem;
		outputLocalRot( obj , sRotHand[ i ] , curScene.currenttime , textFile ) ;
	}
	for( i = 1 ; i <= files.count() ; i++ )
	{
		textFile.writeln( outputTextBuf[ i ] );
	} 
	textFile.close() ;
	
	/* remove IKtoRotClient plugin */
	remove_server( s_xParentItem );
	
	/* pop seleced item  */
	pop_selected_item( ) ;
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}


/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}


outputLocalRot : rootObj,name,time,file
{
	xName = parse( " (" , rootObj.name ) ;
	if( xName[ 1 ] == name )
	{
		vVec = rootObj.getRotation(time) ;
 		file.write( name , ":" );
		file.write( " <" , vVec , ">\n" );
		
		return ;
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		outputLocalRot(childObj,name,time,file);
		childObj = rootObj.nextChild();
	}
}
/* select_by_name */
select_by_name: xRoot , sName 
{
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}
/**/
outputLocalTR : rootObj,name,time,file
{
	xName = parse( " (" , rootObj.name ) ;
	if( xName[ 1 ] == name )
	{
		//vVecRot = rootObj.getWorldRotation(time) ;
		//vVecRot = get_global_rotation( rootObj , time );
		vVecRot = rootObj.getRotation(time) ;
		vVecPos = rootObj.getPosition(time) ;
 		file.write( name , ":LT:" );
		file.write( " <" , vVecPos , ">" );
 		file.write( ":LR:" );
		file.write( " <" , vVecRot , ">\n" );
		
		return ;
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		outputLocalTR(childObj,name,time,file);
		childObj = rootObj.nextChild();
	}
}


/******************    Acs3b Save Bone Rotation Data  ******************/
initItemTable: nType
{
	// Open File
	sFilePath = getdir("Content") + "/temp/localrot" ;
	fileName = sFilePath + "/localrot.opt" ;
	
	if((textFile = File( fileName , "r" ) ) == nil)
	{
		for( nLoop = 1 ; nLoop <= sAMRotName.size() ; nLoop++ )
		{
			s_asRotName[ nLoop ] = sAMRotName[ nLoop ];
		}
	}
	else {
		nCount = 1 ;
		while( textFile.eof() != true)
		{
			s_asRotName[ nCount ] = textFile.read();
			nCount++ ;
		}
		textFile.close();
	}
	for( nLoop = 1 ; nLoop <= sGlobalLNameAM.size() ; nLoop++ )
	{
		s_asControlRotName[ nLoop ] = sGlobalLNameAM[ nLoop ];
	}

}

check_item: xTop,nNum
{
	for( i = 1 ; i <= nNum ; i++ )
	{
		s_xSearchItem = nil ;
		searchItem( xTop , sGlobalTRName[ i ] );
		if( s_xSearchItem == nil )
		{
			if( s_xSearchItem == nil )
			{
				return 0;
			}
		}		
	}
	return TYPE_AM  ;
}

apply_server: xTop 
{
	for( i = 1 ; i <= s_asRotName.size() ; i++ )
	{
		apply_item( xTop , s_asRotName[ i ] );
	}
}

remove_server: xTop 
{
	for( i = 1 ; i <=  s_asRotName.size() ; i++ )
	{
		remove_item( xTop , s_asRotName[ i ] );
	}
}
apply_item : top  , sName 
{
	s_xSearchItem = nil ;
	searchItem( top , sName );
	if( s_xSearchItem != nil )
	{
		SelectItem( s_xSearchItem.id );
		CommandInput( "ApplyServer ItemMotionHandler IKtoRotClient");
	}

}
remove_item : top  , sName 
{
	s_xSearchItem = nil ;
	searchItem( top , sName );
	if( s_xSearchItem != nil )
	{
		SelectItem( s_xSearchItem.id );
		CommandInput( "RemoveServer ItemMotionHandler IKtoRotClient");
	}

}

searchItem: s_xItem , sName 
{
	// use s_xSearchItem 
	xMesh = s_xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = s_xItem.nextChild();
	}
}


/********************************************************/
/*   get_global_rotation                                */
/********************************************************/
get_global_rotation: xItem , time 
{
	var mMtx[4][4] ;
	var vRot = <0,0,0> ;
	
	//vRot = xItem.getWorldRotation(time) ;
	matrix_identity( mMtx );
	//matrix_rotation( mMtx , ( vRot.y / 180 ) * 3.1415927 ,  ( vRot.x / 180 ) * 3.1415927 , ( vRot.z / 180 ) * 3.1415927 );
	//info( "koko_ " , vRot );
	get_global_matrix( xItem , time , mMtx );
	//matrix_print( mtx );
	vTemp = LWMAT_getYXZrotations( mMtx , vRot  );

	vVecRot = <((vTemp[1]*180)/3.1415926),((vTemp[2]*180)/3.1415926),((vTemp[3]*180)/3.1415926)>;
	return vVecRot ;
}
/********************************************************/
/*   get_global_matrix                            */
/********************************************************/
get_global_matrix: xItem , time ,mMtx 
{
	matrix_identity( mMtx );
	while( xItem != nil )
	{
		var mTemp[4][4];
		var mOrg[4][4];
		matrix_copy( mOrg  , mMtx );
		get_item_matrix( xItem , time , mTemp );
		matrix_mul_matrix( mMtx , mOrg , mTemp    );
		xItem = xItem.parent ;
	}
	
}

get_item_matrix : xItem , time , mtx 
{
	vTrans = xItem.getPosition( time );
	vRot   = xItem.getRotation( time );
	vScale   = xItem.getScaling( time );
	//vPivot   = xItem.getPivot( time );
	var mTemp[4][4];
	var mScale[ 4 ][ 4 ] ;
	var mTrans[ 4 ][ 4 ] ;
	var mRot[ 4 ][ 4 ] ;
	
	matrix_copy( mTemp , mtx );
	matrix_scale( mScale , vScale );
	matrix_trans( mTrans , vTrans );
	matrix_rotation( mRot , ( vRot.y / 180 ) * 3.1415927 ,  ( vRot.x / 180 ) * 3.1415927 , ( vRot.z / 180 ) * 3.1415927 );
	// scale -> Rot -> Trans -> Pivot 
	matrix_mul_matrix( mTemp   , mScale , mRot  );
	matrix_mul_matrix( mtx , mTemp , mTrans );
}


/**********************************************/
/*     Matrix                                 */
/**********************************************/
matrix_identity: mtx 
{
	mtx[1][1] = 1; mtx[1][2] = 0;  mtx[1][3] = 0;mtx[1][4] = 0;
	mtx[2][1] = 0; mtx[2][2] = 1;  mtx[2][3] = 0;mtx[2][4] = 0;
	mtx[3][1] = 0; mtx[3][2] = 0;  mtx[3][3] = 1;mtx[3][4] = 0;
	mtx[4][1] = 0; mtx[4][2] = 0;  mtx[4][3] = 0;mtx[4][4] = 1;
}

matrix_trans : mtx , vVec 
{
	mtx[1][1] = 1      ; mtx[1][2] = 0     ;  mtx[1][3] = 0     ;mtx[1][4] = 0;
	mtx[2][1] = 0      ; mtx[2][2] = 1     ;  mtx[2][3] = 0     ;mtx[2][4] = 0;
	mtx[3][1] = 0      ; mtx[3][2] = 0     ;  mtx[3][3] = 1     ;mtx[3][4] = 0;
	mtx[4][1] = vVec.x ; mtx[4][2] = vVec.y;  mtx[4][3] = vVec.z;mtx[4][4] = 1;
}

matrix_scale: mtx , vVec 
{
	mtx[1][1] = vVec.x ; mtx[1][2] = 0     ;  mtx[1][3] = 0     ;mtx[1][4] = 0;
	mtx[2][1] = 0      ; mtx[2][2] = vVec.y;  mtx[2][3] = 0     ;mtx[2][4] = 0;
	mtx[3][1] = 0      ; mtx[3][2] = 0     ;  mtx[3][3] = vVec.z;mtx[3][4] = 0;
	mtx[4][1] = 0      ; mtx[4][2] = 0     ;  mtx[4][3] = 0     ;mtx[4][4] = 1;
}

matrix_rotate_x: mtx ,dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = 1.0 ; mtx[1][2] = 0;     mtx[1][3] = 0;    mtx[1][4] = 0;
	mtx[2][1] = 0;    mtx[2][2] = dcos;  mtx[2][3] = dsin; mtx[2][4] = 0;
	mtx[3][1] = 0;    mtx[3][2] = -dsin; mtx[3][3] = dcos; mtx[3][4] = 0;
	mtx[4][1] = 0;    mtx[4][2] =  0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}                                                          

matrix_rotate_y:  mtx , dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = dcos; mtx[1][2] = 0;  mtx[1][3] = -dsin;   mtx[1][4] = 0;
	mtx[2][1] = 0;    mtx[2][2] = 1;  mtx[2][3] = 0;       mtx[2][4] = 0;
	mtx[3][1] = dsin; mtx[3][2] = 0;  mtx[3][3] = dcos;    mtx[3][4] = 0;
	mtx[4][1] = 0;    mtx[4][2] =  0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}

matrix_rotate_z:  mtx , dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = dcos;  mtx[1][2] = dsin;  mtx[1][3] = 0;   mtx[1][4] = 0;
	mtx[2][1] = -dsin; mtx[2][2] = dcos;  mtx[2][3] = 0;   mtx[2][4] = 0;
	mtx[3][1] = 0 ;    mtx[3][2] = 0;     mtx[3][3] = 1;   mtx[3][4] = 0;
	mtx[4][1] = 0;     mtx[4][2] = 0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}

matrix_rotation: mtx , x , y , z  
{
	var mX[4][4];
	var mY[4][4];
	var mZ[4][4];
	var mT[4][4];
	
	matrix_rotate_x( mX , x );
	matrix_rotate_y( mY , y );
	matrix_rotate_z( mZ , z );
	
	matrix_mul_matrix( mT , mX  , mY );
	matrix_mul_matrix( mtx , mZ  , mT );
}

matrix_mul_vector : inM , vVec
{
	vOutVec = < 0 , 0 , 0 >;
	vOutVec.x = inM[1][1] * vVec.x + inM[2][1] * vVec.y + inM[3][1] * vVec.z + inM[4][1] ;
	vOutVec.y = inM[1][2] * vVec.x + inM[2][2] * vVec.y + inM[3][2] * vVec.z + inM[4][2] ;
	vOutVec.z = inM[1][3] * vVec.x + inM[2][3] * vVec.y + inM[3][3] * vVec.z + inM[4][3] ;

	return vOutVec ;                                                         
}                                                                            
                                                                             
matrix_mul_matrix : ansM , inM1 , inM2 
{
	ansM[1][1] = inM1[1][1] * inM2[1][1] + inM1[1][2] * inM2[2][1] + inM1[1][3] * inM2[3][1] + inM1[1][4] * inM2[4][1]; 
	ansM[1][2] = inM1[1][1] * inM2[1][2] + inM1[1][2] * inM2[2][2] + inM1[1][3] * inM2[3][2] + inM1[1][4] * inM2[4][2]; 
	ansM[1][3] = inM1[1][1] * inM2[1][3] + inM1[1][2] * inM2[2][3] + inM1[1][3] * inM2[3][3] + inM1[1][4] * inM2[4][3]; 
	ansM[1][4] = inM1[1][1] * inM2[1][4] + inM1[1][2] * inM2[2][4] + inM1[1][3] * inM2[3][4] + inM1[1][4] * inM2[4][4]; 
	ansM[2][1] = inM1[2][1] * inM2[1][1] + inM1[2][2] * inM2[2][1] + inM1[2][3] * inM2[3][1] + inM1[2][4] * inM2[4][1];  
	ansM[2][2] = inM1[2][1] * inM2[1][2] + inM1[2][2] * inM2[2][2] + inM1[2][3] * inM2[3][2] + inM1[2][4] * inM2[4][2];   
	ansM[2][3] = inM1[2][1] * inM2[1][3] + inM1[2][2] * inM2[2][3] + inM1[2][3] * inM2[3][3] + inM1[2][4] * inM2[4][3]; 
	ansM[2][4] = inM1[2][1] * inM2[1][4] + inM1[2][2] * inM2[2][4] + inM1[2][3] * inM2[3][4] + inM1[2][4] * inM2[4][4]; 
	ansM[3][1] = inM1[3][1] * inM2[1][1] + inM1[3][2] * inM2[2][1] + inM1[3][3] * inM2[3][1] + inM1[3][4] * inM2[4][1];  
	ansM[3][2] = inM1[3][1] * inM2[1][2] + inM1[3][2] * inM2[2][2] + inM1[3][3] * inM2[3][2] + inM1[3][4] * inM2[4][2]; 
	ansM[3][3] = inM1[3][1] * inM2[1][3] + inM1[3][2] * inM2[2][3] + inM1[3][3] * inM2[3][3] + inM1[3][4] * inM2[4][3]; 
	ansM[3][4] = inM1[3][1] * inM2[1][4] + inM1[3][2] * inM2[2][4] + inM1[3][3] * inM2[3][4] + inM1[3][4] * inM2[4][4]; 
	ansM[4][1] = inM1[4][1] * inM2[1][1] + inM1[4][2] * inM2[2][1] + inM1[4][3] * inM2[3][1] + inM1[4][4] * inM2[4][1];  
	ansM[4][2] = inM1[4][1] * inM2[1][2] + inM1[4][2] * inM2[2][2] + inM1[4][3] * inM2[3][2] + inM1[4][4] * inM2[4][2]; 
	ansM[4][3] = inM1[4][1] * inM2[1][3] + inM1[4][2] * inM2[2][3] + inM1[4][3] * inM2[3][3] + inM1[4][4] * inM2[4][3]; 
	ansM[4][4] = inM1[4][1] * inM2[1][4] + inM1[4][2] * inM2[2][4] + inM1[4][3] * inM2[3][4] + inM1[4][4] * inM2[4][4]; 

}                                                                                           


matrix_mul_value: ansM , inValue 
{
	ansM[1][1] *= inValue ; ansM[1][2] *= inValue ;  ansM[1][3] *= inValue  ; ansM[1][4] *= inValue  ;
	ansM[2][1] *= inValue ; ansM[2][2] *= inValue ;  ansM[2][3] *= inValue  ; ansM[2][4] *= inValue  ;
	ansM[3][1] *= inValue ; ansM[3][2] *= inValue ;  ansM[3][3] *= inValue  ; ansM[3][4] *= inValue  ;
	ansM[4][1] *= inValue ; ansM[4][2] *= inValue ;  ansM[4][3] *= inValue  ; ansM[4][4] *= inValue  ;
}                                                                             
                                                                              
matrix_multipry : ansM , inM                                                  
{
	ansM[1][1] *= inM[1][1] ; ansM[1][2] *= inM[1][2] ;  ansM[1][3] *= inM[1][3] ; ansM[1][4] *= inM[1][4] ;
	ansM[2][1] *= inM[2][1] ; ansM[2][2] *= inM[2][2] ;  ansM[2][3] *= inM[2][3] ; ansM[2][4] *= inM[2][4] ;
	ansM[3][1] *= inM[3][1] ; ansM[3][2] *= inM[3][2] ;  ansM[3][3] *= inM[3][3] ; ansM[3][4] *= inM[3][4] ;
	ansM[4][1] *= inM[4][1] ; ansM[4][2] *= inM[4][2] ;  ansM[4][3] *= inM[4][3]  ;ansM[4][4] *= inM[4][4] ;
}	                                                                               
                                                                                   
matrix_add: ansM , inM 
{
	ansM[1][1] += inM[1][1] ; ansM[1][2] += inM[1][2] ;  ansM[1][3] += inM[1][3] ; ansM[1][4] += inM[1][4] ;
	ansM[2][1] += inM[2][1] ; ansM[2][2] += inM[2][2] ;  ansM[2][3] += inM[2][3] ; ansM[2][4] += inM[2][4] ;
	ansM[3][1] += inM[3][1] ; ansM[3][2] += inM[3][2] ;  ansM[3][3] += inM[3][3] ; ansM[3][4] += inM[3][4] ;
	ansM[4][1] += inM[4][1] ; ansM[4][2] += inM[4][2] ;  ansM[4][3] += inM[4][3] ; ansM[4][4] += inM[4][4] ;
}	                                                                              

matrix_copy: srcM , dstM 
{
	srcM[1][1] = dstM[1][1] ; srcM[1][2] = dstM[1][2] ;  srcM[1][3] = dstM[1][3] ; srcM[1][4] = dstM[1][4] ;
	srcM[2][1] = dstM[2][1] ; srcM[2][2] = dstM[2][2] ;  srcM[2][3] = dstM[2][3] ; srcM[2][4] = dstM[2][4] ;
	srcM[3][1] = dstM[3][1] ; srcM[3][2] = dstM[3][2] ;  srcM[3][3] = dstM[3][3] ; srcM[3][4] = dstM[3][4] ;
	srcM[4][1] = dstM[4][1] ; srcM[4][2] = dstM[4][2] ;  srcM[4][3] = dstM[4][3] ; srcM[4][4] = dstM[4][4] ;
	                                                                               
}                                                                                  
                                                                                   

matrix_determinant: mtx 
{
	return (  ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 2 ] - mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 3 ] )
			- ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 3 ] - mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 2 ] )
			+ ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 3 ] - mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 2 ] )
			+ ( mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 3 ] - mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 2 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 1 ] )
			- ( mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 2 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 3 ] - mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 1 ] )
			+ ( mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 3 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 2 ] - mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 1 ] )
			);                                     
}                                                  

matrix_mul_value : mtx, fVal 
{
	mtx[1][1] *= fVal; mtx[1][2] *= fVal;  mtx[1][3] *= fVal; mtx[1][4] *= fVal;
	mtx[2][1] *= fVal; mtx[2][2] *= fVal;  mtx[2][3] *= fVal; mtx[2][4] *= fVal;
	mtx[3][1] *= fVal; mtx[3][2] *= fVal;  mtx[3][3] *= fVal; mtx[3][4] *= fVal;
	mtx[4][1] *= fVal; mtx[4][2] *= fVal;  mtx[4][3] *= fVal; mtx[4][4] *= fVal;
}

matrix_invert: ansMtx , mtx 
{
	fDet = matrix_determinant( mtx );
	if ( dDet == 0.0 ) return;
	fDet = 1 / fDet ;


	ansMtx[1][1] = mtx[2][2]*(mtx[3][3]*mtx[4][4] - mtx[3][4]*mtx[4][3]) + mtx[2][3]*(mtx[3][4]*mtx[4][2] - mtx[3][2]*mtx[4][4]) + mtx[2][4]*(mtx[3][2]*mtx[4][3] - mtx[3][3]*mtx[4][2]);
	ansMtx[1][2] = mtx[3][2]*(mtx[1][3]*mtx[4][4] - mtx[1][4]*mtx[4][3]) + mtx[3][3]*(mtx[1][4]*mtx[4][2] - mtx[1][2]*mtx[4][4]) + mtx[3][4]*(mtx[1][2]*mtx[4][3] - mtx[1][3]*mtx[4][2]);
	ansMtx[1][3] = mtx[4][2]*(mtx[1][3]*mtx[2][4] - mtx[1][4]*mtx[2][3]) + mtx[4][3]*(mtx[1][4]*mtx[2][2] - mtx[1][2]*mtx[2][4]) + mtx[4][4]*(mtx[1][2]*mtx[2][3] - mtx[1][3]*mtx[2][2]);
	ansMtx[1][4] = mtx[1][2]*(mtx[2][4]*mtx[3][3] - mtx[2][3]*mtx[3][4]) + mtx[1][3]*(mtx[2][2]*mtx[3][4] - mtx[2][4]*mtx[3][2]) + mtx[1][4]*(mtx[2][3]*mtx[3][2] - mtx[2][2]*mtx[3][3]);

	ansMtx[2][1] = mtx[2][3]*(mtx[3][1]*mtx[4][4] - mtx[3][4]*mtx[4][1]) + mtx[2][4]*(mtx[3][3]*mtx[4][1] - mtx[3][1]*mtx[4][3]) + mtx[2][1]*(mtx[3][4]*mtx[4][3] - mtx[3][3]*mtx[4][4]);
	ansMtx[2][2] = mtx[3][3]*(mtx[1][1]*mtx[4][4] - mtx[1][4]*mtx[4][1]) + mtx[3][4]*(mtx[1][3]*mtx[4][1] - mtx[1][1]*mtx[4][3]) + mtx[3][1]*(mtx[1][4]*mtx[4][3] - mtx[1][3]*mtx[4][4]);
	ansMtx[2][3] = mtx[4][3]*(mtx[1][1]*mtx[2][4] - mtx[1][4]*mtx[2][1]) + mtx[4][4]*(mtx[1][3]*mtx[2][1] - mtx[1][1]*mtx[2][3]) + mtx[4][1]*(mtx[1][4]*mtx[2][3] - mtx[1][3]*mtx[2][4]);
	ansMtx[2][4] = mtx[1][3]*(mtx[2][4]*mtx[3][1] - mtx[2][1]*mtx[3][4]) + mtx[1][4]*(mtx[2][1]*mtx[3][3] - mtx[2][3]*mtx[3][1]) + mtx[1][1]*(mtx[2][3]*mtx[3][4] - mtx[2][4]*mtx[3][3]);

	ansMtx[3][1] = mtx[2][4]*(mtx[3][1]*mtx[4][2] - mtx[3][2]*mtx[4][1]) + mtx[2][1]*(mtx[3][2]*mtx[4][4] - mtx[3][4]*mtx[4][2]) + mtx[2][2]*(mtx[3][4]*mtx[4][1] - mtx[3][1]*mtx[4][4]);
	ansMtx[3][2] = mtx[3][4]*(mtx[1][1]*mtx[4][2] - mtx[1][2]*mtx[4][1]) + mtx[3][1]*(mtx[1][2]*mtx[4][4] - mtx[1][4]*mtx[4][2]) + mtx[3][2]*(mtx[1][4]*mtx[4][1] - mtx[1][1]*mtx[4][4]);
	ansMtx[3][3] = mtx[4][4]*(mtx[1][1]*mtx[2][2] - mtx[1][2]*mtx[2][1]) + mtx[4][1]*(mtx[1][2]*mtx[2][4] - mtx[1][4]*mtx[2][2]) + mtx[4][2]*(mtx[1][4]*mtx[2][1] - mtx[1][1]*mtx[2][4]);
	ansMtx[3][4] = mtx[1][4]*(mtx[2][2]*mtx[3][1] - mtx[2][1]*mtx[3][2]) + mtx[1][1]*(mtx[2][4]*mtx[3][2] - mtx[2][2]*mtx[3][4]) + mtx[1][2]*(mtx[2][1]*mtx[3][4] - mtx[2][4]*mtx[3][1]);

	ansMtx[4][1] = mtx[2][1]*(mtx[3][3]*mtx[4][2] - mtx[3][2]*mtx[4][3]) + mtx[2][2]*(mtx[3][1]*mtx[4][3] - mtx[3][3]*mtx[4][1]) + mtx[2][3]*(mtx[3][2]*mtx[4][1] - mtx[3][1]*mtx[4][2]);
	ansMtx[4][2] = mtx[3][1]*(mtx[1][3]*mtx[4][2] - mtx[1][2]*mtx[4][3]) + mtx[3][2]*(mtx[1][1]*mtx[4][3] - mtx[1][3]*mtx[4][1]) + mtx[3][3]*(mtx[1][2]*mtx[4][1] - mtx[1][1]*mtx[4][2]);
	ansMtx[4][3] = mtx[4][1]*(mtx[1][3]*mtx[2][2] - mtx[1][2]*mtx[2][3]) + mtx[4][2]*(mtx[1][1]*mtx[2][3] - mtx[1][3]*mtx[2][1]) + mtx[4][3]*(mtx[1][2]*mtx[2][1] - mtx[1][1]*mtx[2][2]);
	ansMtx[4][4] = mtx[1][1]*(mtx[2][2]*mtx[3][3] - mtx[2][3]*mtx[3][2]) + mtx[1][2]*(mtx[2][3]*mtx[3][1] - mtx[2][1]*mtx[3][3]) + mtx[1][3]*(mtx[2][1]*mtx[3][2] - mtx[2][2]*mtx[3][1]);
	                                                     
                                                 
	matrix_mul_value( ansMtx , fDet );
}

sgn: val
{
	if( val > 0.0 )
	{
		return 1 ;
	}
	else {
		return -1 ;
	} 
}

atan2:  y , x
{
	if( -0.000001 < x && x < 0.000001 )
	{
		if( -0.000001 < y && y <  0.000001 )
		{
			val = 0 ;
		}
		else {
			val = sgn(y) *  3.1415927 / 2 ;
		}
	}
	else if( x < 0 ) 
	{
		if( -0.000001 < y && y <  0.000001 )
		{
			val =  3.1415927  ;
		}
		else {
			val =  sgn(y) * 3.1415927 +  atan( y / x ) ;
		}
	}
	else {
		val =  atan( y / x ) ;
	}
	return val ;
}

LWMAT_getYXZrotations:  mtx , vec
{
	// Pitch
	var cp;
	var s;
	var c;
	var vTemp = <0,0,0>;

	// X
	if( mtx[3][2] > 1.0 )
	{
		vec[2] =asin(-1.0);
	}
	else if(mtx[3][2] < -1.0)
	{
		vec[2] = asin(1.0);
	}
	else
	{
		vec[2] = asin(-1.0 * mtx[3][2]);
	}
	cp = cos(vec[2]);

    if( !( -0.000001 < cp && cp < 0.000001 ) )
    {
		// Y
		s = mtx[3][1] / cp;
		c = mtx[3][3] / cp;
		vec[1] = atan2( s , c) ;

		// Z
		s = mtx[1][2] / cp;
		c = mtx[2][2] / cp;
		vec[3] = atan2( s , c);

 		if( abs(vec[ 3 ]) > ( 3.14159265 - 0.2 ) && abs(vec[ 1 ])  > ( 3.14159265 - 0.2 ) )
		{
			vec[2] = 3.14159265 - vec[2] ;
			cp = cos( vec[2] );			
			// Y
			s = mtx[3][1] / cp;
			c = mtx[3][3] / cp;
			vec[1] = atan2( s , c) ;

			// Z
			s = mtx[1][2] / cp;
			c = mtx[2][2] / cp;
			vec[3] = atan2( s , c);			
		}		
	}
	else
	{
		vec[1] = 0.0;
		vec[3] = atan2( mtx[1][3], mtx[2][3]);
		val = vec[2]+1.57080 ;
		if( -0.000001 < val &&  val < 0.000001 )
		{
			vec[1] = -vec[1];
			vec[2] = -vec[2];
			vec[3] = -vec[3];
		}
    }
    vTemp = vec ;
    return vTemp ;
}

matrix_print: mtx 
{
	info( "(" , mtx[1][1] , " , " , mtx[1][2] , " , "  , mtx[1][3] , " , "  , mtx[1][4], ")-(" ,
	            mtx[2][1] , " , " , mtx[2][2] , " , "  , mtx[2][3] , " , "  , mtx[2][4], ")-(" ,
	            mtx[3][1] , " , " , mtx[3][2] , " , "  , mtx[3][3] , " , "  , mtx[3][4], ")-(" ,
	            mtx[4][1] , " , " , mtx[4][2] , " , "  , mtx[4][3] , " , "  , mtx[4][4], ")" );
}

vector_print: vec
{
	info( "(" , vec.x , " , " , vec.y , " , "  , vec.z , ")" );
}
